Index: docs/flatpages.txt
===================================================================
--- docs/flatpages.txt	(revision 2488)
+++ docs/flatpages.txt	(working copy)
@@ -35,9 +35,9 @@
 ============
 
 ``django-admin.py install flatpages`` creates two tables in your database:
-``django_flatpages`` and ``django_flatpages_sites``. ``django_flatpages`` is a
+``django_flatpage`` and ``django_flatpage_sites``. ``django_flatpage`` is a
 simple lookup table that essentially maps a URL to a title and bunch of text
-content. ``django_flatpages_sites`` associates a flatpage with a site.
+content. ``django_flatpage_sites`` associates a flatpage with a site.
 
 The ``FlatpageFallbackMiddleware`` does all of the work. Each time any Django
 application raises a 404 error, this middleware checks the flatpages database
Index: docs/legacy_databases.txt
===================================================================
--- docs/legacy_databases.txt	(revision 2488)
+++ docs/legacy_databases.txt	(working copy)
@@ -66,17 +66,16 @@
 This won't work if your database already contains tables that have any of the
 following names:
 
-    * ``sites``
-    * ``packages``
-    * ``content_types``
-    * ``core_sessions``
-    * ``auth_permissions``
-    * ``auth_groups``
-    * ``auth_users``
-    * ``auth_messages``
-    * ``auth_groups_permissions``
-    * ``auth_users_groups``
-    * ``auth_users_user_permissions``
+    * ``django_site``
+    * ``django_content_type``
+    * ``django_sessions``
+    * ``auth_permission``
+    * ``auth_group``
+    * ``auth_user``
+    * ``auth_message``
+    * ``auth_group_permissions``
+    * ``auth_user_groups``
+    * ``auth_user_user_permission``
 
 If that's the case, try renaming one of your tables to resolve naming
 conflicts. Currently, there's no way of customizing the names of Django's
Index: docs/model-api.txt
===================================================================
--- docs/model-api.txt	(revision 2488)
+++ docs/model-api.txt	(working copy)
@@ -733,7 +733,7 @@
 
         db_table = "pizza_orders"
 
-    If this isn't given, Django will use ``app_label + '_' + module_name``.
+    If this isn't given, Django will use ``app_label + '_' + model_class_name``.
 
     If your database table name is an SQL reserved word, or contains characters
     that aren't allowed in Python variable names -- notably, the hyphen --
Index: docs/redirects.txt
===================================================================
--- docs/redirects.txt	(revision 2488)
+++ docs/redirects.txt	(working copy)
@@ -21,7 +21,7 @@
 How it works
 ============
 
-``django-admin.py install redirects`` creates a ``django_redirects`` table in
+``django-admin.py install redirects`` creates a ``django_redirect`` table in
 your database. This is a simple lookup table with ``site_id``, ``old_path`` and
 ``new_path`` fields.
 
Index: docs/sessions.txt
===================================================================
--- docs/sessions.txt	(revision 2488)
+++ docs/sessions.txt	(working copy)
@@ -239,7 +239,7 @@
     * The session dictionary should accept any pickleable Python object. See
       `the pickle module`_ for more information.
 
-    * Session data is stored in a database table named ``core_sessions`` .
+    * Session data is stored in a database table named ``django_session`` .
 
     * Django only sends a cookie if it needs to. If you don't set any session
       data, it won't send a session cookie.
Index: docs/settings.txt
===================================================================
--- docs/settings.txt	(revision 2488)
+++ docs/settings.txt	(working copy)
@@ -563,9 +563,9 @@
 
 Default: Not defined
 
-The ID, as an integer, of the current site in the ``sites`` database. This is
-used so that application data can hook into specific site(s) and a single
-database can manage content for multiple sites.
+The ID, as an integer, of the current site in the ``django_site`` database
+table. This is used so that application data can hook into specific site(s)
+and a single database can manage content for multiple sites.
 
 TEMPLATE_CONTEXT_PROCESSORS
 ---------------------------