Index: django/views/generic/date_based.py
===================================================================
--- django/views/generic/date_based.py	(revision 13294)
+++ django/views/generic/date_based.py	(working copy)
@@ -294,17 +294,17 @@
             c[key] = value
     return HttpResponse(t.render(c), mimetype=mimetype)
 
-def archive_today(request, **kwargs):
+def archive_today(request, month_format='%b', **kwargs):
     """
     Generic daily archive view for today. Same as archive_day view.
     """
     today = datetime.date.today()
     kwargs.update({
         'year': str(today.year),
-        'month': today.strftime('%b').lower(),
+        'month': today.strftime(month_format).lower(),
         'day': str(today.day),
     })
-    return archive_day(request, **kwargs)
+    return archive_day(request, month_format=month_format, **kwargs)
 
 def object_detail(request, year, month, day, queryset, date_field,
         month_format='%b', day_format='%d', object_id=None, slug=None,
Index: tests/regressiontests/views/tests/generic/date_based.py
===================================================================
--- tests/regressiontests/views/tests/generic/date_based.py	(revision 13294)
+++ tests/regressiontests/views/tests/generic/date_based.py	(working copy)
@@ -128,7 +128,42 @@
         self.assertEqual(len(response.context['date_list']), 2)
 
 class DayArchiveTests(TestCase):
-
+    fixtures = ['testdata.json']
+    
+    def setUp(self):
+        # Correct the date for the current article
+        current_article = Article.objects.get(title="Current Article")
+        current_article.date_created = datetime.now() 
+        current_article.save()
+    
+    def test_archive_today(self):
+        response = self.client.get('/views/date_based/today/')
+        self.assertEqual(response.status_code, 200)
+        objects = response.context['object_list']
+        self.assertEqual(len(objects), 1)
+        self.assertEqual(objects[0].title, 'Current Article')
+    
+    def test_archive_today_month_format(self):
+        response = self.client.get('/views/date_based/today_month_format/')
+        self.assertEqual(response.status_code, 200)
+        objects = response.context['object_list']
+        self.assertEqual(len(objects), 1)
+        self.assertEqual(objects[0].title, 'Current Article')
+    
+    def test_archive_day_abbrev_month(self):
+        response = self.client.get('/views/date_based/archive_day/2001/jan/1/')
+        self.assertEqual(response.status_code, 200)
+        objects = response.context['object_list']
+        self.assertEqual(len(objects), 1)
+        self.assertEqual(objects[0].title, 'Old Article')
+    
+    def test_archive_day_numeric_month(self):
+        response = self.client.get('/views/date_based/archive_day/2001/1/1/')
+        self.assertEqual(response.status_code, 200)
+        objects = response.context['object_list']
+        self.assertEqual(len(objects), 1)
+        self.assertEqual(objects[0].title, 'Old Article')
+        
     def test_year_month_day_format(self):
         """
         Make sure day views don't get confused with numeric month formats (#7944)
Index: tests/regressiontests/views/urls.py
===================================================================
--- tests/regressiontests/views/urls.py	(revision 13294)
+++ tests/regressiontests/views/urls.py	(working copy)
@@ -74,6 +74,18 @@
     (r'^date_based/datefield/archive_month/(?P<year>\d{4})/(?P<month>\d{1,2})/$',
         'archive_month',
         date_based_datefield_info_dict),
+    (r'^date_based/today/$',
+        'archive_today',
+        date_based_info_dict),
+    (r'^date_based/today_month_format/$',
+        'archive_today',
+        dict(date_based_info_dict, month_format='%m')),
+    (r'^date_based/archive_day/(?P<year>\d{4})/(?P<month>\w{3})/(?P<day>\d{1,2})/$',
+        'archive_day',
+        dict(date_based_info_dict, month_format='%b')),
+    (r'^date_based/archive_day/(?P<year>\d{4})/(?P<month>\d{1,2})/(?P<day>\d{1,2})/$',
+        'archive_day',
+        dict(date_based_info_dict, month_format='%m')),
 )
 
 # crud generic views.