Index: django/contrib/admin/templatetags/log.py
===================================================================
--- django/contrib/admin/templatetags/log.py	(revision 2205)
+++ django/contrib/admin/templatetags/log.py	(working copy)
@@ -13,8 +13,7 @@
     def render(self, context):
         if self.user is not None and not self.user.isdigit():
             self.user = context[self.user].id
-        context[self.varname] = LogEntry.objects.get_list(user__id__exact=self.user,
-            limit=self.limit, select_related=True)
+        context[self.varname] = LogEntry.objects.filter(user__id__exact=self.user).select_related()[:self.limit]
         return ''
 
 class DoGetAdminLog:
Index: django/contrib/admin/filterspecs.py
===================================================================
--- django/contrib/admin/filterspecs.py	(revision 2205)
+++ django/contrib/admin/filterspecs.py	(working copy)
@@ -56,7 +56,7 @@
             self.lookup_title = f.verbose_name
         self.lookup_kwarg = '%s__%s__exact' % (f.name, f.rel.to._meta.pk.name)
         self.lookup_val = request.GET.get(self.lookup_kwarg, None)
-        self.lookup_choices = f.rel.to._default_manager.get_list()
+        self.lookup_choices = f.rel.to._default_manager.all()
 
     def has_output(self):
         return len(self.lookup_choices) > 1
Index: django/contrib/admin/views/decorators.py
===================================================================
--- django/contrib/admin/views/decorators.py	(revision 2205)
+++ django/contrib/admin/views/decorators.py	(working copy)
@@ -71,13 +71,13 @@
         # Check the password.
         username = request.POST.get('username', '')
         try:
-            user = User.objects.get_object(username__exact=username, is_staff__exact=True)
+            user = User.objects.get(username=username, is_staff=True)
         except User.DoesNotExist:
             message = ERROR_MESSAGE
             if '@' in username:
                 # Mistakenly entered e-mail address instead of username? Look it up.
                 try:
-                    user = User.objects.get_object(email__exact=username)
+                    user = User.objects.get(email=username)
                 except User.DoesNotExist:
                     message = _("Usernames cannot contain the '@' character.")
                 else:
Index: django/contrib/admin/views/doc.py
===================================================================
--- django/contrib/admin/views/doc.py	(revision 2205)
+++ django/contrib/admin/views/doc.py	(working copy)
@@ -103,7 +103,7 @@
                 'name': func.__name__,
                 'module': func.__module__,
                 'site_id': settings_mod.SITE_ID,
-                'site': Site.objects.get_object(pk=settings_mod.SITE_ID),
+                'site': Site.objects.get(pk=settings_mod.SITE_ID),
                 'url': simplify_regex(regex),
             })
     return render_to_response('admin_doc/view_index', {'views': views}, context_instance=RequestContext(request))
@@ -206,7 +206,7 @@
                 'exists': os.path.exists(template_file),
                 'contents': lambda: os.path.exists(template_file) and open(template_file).read() or '',
                 'site_id': settings_mod.SITE_ID,
-                'site': Site.objects.get_object(pk=settings_mod.SITE_ID),
+                'site': Site.objects.get(pk=settings_mod.SITE_ID),
                 'order': list(settings_mod.TEMPLATE_DIRS).index(dir),
             })
     return render_to_response('admin_doc/template_detail', {
Index: django/contrib/auth/handlers/modpython.py
===================================================================
--- django/contrib/auth/handlers/modpython.py	(revision 2205)
+++ django/contrib/auth/handlers/modpython.py	(working copy)
@@ -21,13 +21,13 @@
     superuser_only = _str_to_bool(options.get('DjangoRequireSuperuserStatus', "off"))
 
     # check that the username is valid
-    kwargs = {'username__exact': req.user, 'is_active__exact': True}
+    kwargs = {'username': req.user, 'is_active': True}
     if staff_only:
-        kwargs['is_staff__exact'] = True
+        kwargs['is_staff'] = True
     if superuser_only:
-        kwargs['is_superuser__exact'] = True
+        kwargs['is_superuser'] = True
     try:
-        user = User.objects.get_object(**kwargs)
+        user = User.objects.get(**kwargs)
     except User.DoesNotExist:
         return apache.HTTP_UNAUTHORIZED
 
Index: django/contrib/auth/models.py
===================================================================
--- django/contrib/auth/models.py	(revision 2205)
+++ django/contrib/auth/models.py	(working copy)
@@ -183,7 +183,7 @@
 
     def get_and_delete_messages(self):
         messages = []
-        for m in self.get_message_list():
+        for m in self.message_set.all():
             messages.append(m.message)
             m.delete()
         return messages
@@ -205,11 +205,11 @@
             try:
                 app, mod = settings.AUTH_PROFILE_MODULE.split('.')
                 module = __import__('ellington.%s.apps.%s' % (app, mod), [], [], [''])
-                self._profile_cache = module.get_object(user_id=self.id)
+                self._profile_cache = module.get(user_id=self.id)
             except ImportError:
                 try:
                     module = __import__('django.models.%s' % settings.AUTH_PROFILE_MODULE, [], [], [''])
-                    self._profile_cache = module.get_object(user__id__exact=self.id)
+                    self._profile_cache = module.get(user__id__exact=self.id)
                 except ImportError:
                     raise SiteProfileNotAvailable
         return self._profile_cache
Index: django/core/handlers/wsgi.py
===================================================================
--- django/core/handlers/wsgi.py	(revision 2205)
+++ django/core/handlers/wsgi.py	(working copy)
@@ -126,7 +126,7 @@
                 user_id = self.session[SESSION_KEY]
                 if not user_id:
                     raise ValueError
-                self._user = User.objects.get_object(pk=user_id)
+                self._user = User.objects.get(pk=user_id)
             except (AttributeError, KeyError, ValueError, User.DoesNotExist):
                 from django.parts.auth import anonymoususers
                 self._user = anonymoususers.AnonymousUser()
Index: django/core/handlers/modpython.py
===================================================================
--- django/core/handlers/modpython.py	(revision 2205)
+++ django/core/handlers/modpython.py	(working copy)
@@ -105,7 +105,7 @@
                 user_id = self.session[SESSION_KEY]
                 if not user_id:
                     raise ValueError
-                self._user = User.objects.get_object(pk=user_id)
+                self._user = User.objects.get(pk=user_id)
             except (AttributeError, KeyError, ValueError, User.DoesNotExist):
                 from django.parts.auth import anonymoususers
                 self._user = anonymoususers.AnonymousUser()
Index: django/core/management.py
===================================================================
--- django/core/management.py	(revision 2205)
+++ django/core/management.py	(working copy)
@@ -559,12 +559,12 @@
     num_added = 0
     app_models = get_models(app)
     app_label = app_models[0]._meta.app_label
-    package = Package.objects.get_object(pk=app_label)
+    package = Package.objects.get(pk=app_label)
     for klass in app_models:
         opts = klass._meta
         for codename, name in _get_all_permissions(opts):
             try:
-                Permission.objects.get_object(name__exact=name, codename__exact=codename, package__label__exact=package.label)
+                Permission.objects.get(name=name, codename=codename, package__label__exact=package.label)
             except Permission.DoesNotExist:
                 p = Permission(name=name, package=package, codename=codename)
                 p.save()
@@ -644,7 +644,7 @@
                 sys.stderr.write("Error: That username is invalid.\n")
                 username = None
             try:
-                User.objects.get_object(username__exact=username)
+                User.objects.get(username=username)
             except User.DoesNotExist:
                 break
             else:
Index: django/core/paginator.py
===================================================================
--- django/core/paginator.py	(revision 2205)
+++ django/core/paginator.py	(working copy)
@@ -16,7 +16,7 @@
     Finally, check if a page number has a next/prev page using
     has_next_page(page_number) and has_previous_page(page_number).
     """
-    def __init__(self, manager_or_model, args, num_per_page, count_method='get_count', list_method='get_list'):
+    def __init__(self, manager_or_model, args, num_per_page, count_method='count', list_method='all'):
         if hasattr(manager_or_model, '_default_manager'):
             manager = manager_or_model._default_manager
         else:
Index: django/db/models/fields/__init__.py
===================================================================
--- django/db/models/fields/__init__.py	(revision 2205)
+++ django/db/models/fields/__init__.py	(working copy)
@@ -256,7 +256,7 @@
             return first_choice + list(self.choices)
         rel_model = self.rel.to
         return first_choice + [(x._get_pk_val(), str(x))
-                               for x in rel_model._default_manager.get_list(**rel_model._meta.limit_choices_to)]
+                               for x in rel_model._default_manager.filter(**rel_model._meta.limit_choices_to)]
 
     def get_choices_default(self):
         if self.radio_admin:
Index: django/db/models/options.py
===================================================================
--- django/db/models/options.py	(revision 2205)
+++ django/db/models/options.py	(working copy)
@@ -87,7 +87,7 @@
         "Returns the content-type ID for this object type."
         if not hasattr(self, '_content_type_id'):
             from django.contrib.contenttypes.models import ContentType
-            self._content_type_id = ContentType.objects.get_object(
+            self._content_type_id = ContentType.objects.get(
                 python_module_name__exact=self.module_name,
                 package__label__exact=self.app_label).id
         return self._content_type_id
Index: django/db/models/manipulators.py
===================================================================
--- django/db/models/manipulators.py	(revision 2205)
+++ django/db/models/manipulators.py	(working copy)
@@ -250,7 +250,7 @@
     def __init__(self, obj_key, follow=None):
         self.obj_key = obj_key
         try:
-            self.original_object = self.manager.get_object(pk=obj_key)
+            self.original_object = self.manager.get(pk=obj_key)
         except ObjectDoesNotExist:
             # If the object doesn't exist, this might be a manipulator for a
             # one-to-one related object that hasn't created its subobject yet.
Index: django/contrib/contenttypes/models.py
===================================================================
--- django/contrib/contenttypes/models.py	(revision 2126)
+++ django/contrib/contenttypes/models.py	(working copy)
@@ -1,35 +1,24 @@
 from django.db import models
 from django.utils.translation import gettext_lazy as _
 
-class Package(models.Model):
-    label = models.CharField(_('label'), maxlength=20, primary_key=True)
-    name = models.CharField(_('name'), maxlength=30, unique=True)
-    class Meta:
-        verbose_name = _('package')
-        verbose_name_plural = _('packages')
-        db_table = 'django_package'
-        ordering = ('name',)
-
-    def __repr__(self):
-        return self.name
-
 class ContentType(models.Model):
     name = models.CharField(_('name'), maxlength=100)
-    package = models.ForeignKey(Package, db_column='package')
-    python_module_name = models.CharField(_('python module name'), maxlength=50)
+    model = models.CharField(_('python model class name'), maxlength=100, unique=True)
     class Meta:
         verbose_name = _('content type')
         verbose_name_plural = _('content types')
         db_table = 'django_content_type'
-        ordering = ('package', 'name')
-        unique_together = (('package', 'python_module_name'),)
+        ordering = ('name',)
 
     def __repr__(self):
-        return "%s | %s" % (self.package_id, self.name)
+        return self.name
 
     def get_model_module(self):
-        "Returns the Python model module for accessing this type of content."
-        return __import__('django.models.%s.%s' % (self.package_id, self.python_module_name), '', '', [''])
+        "Returns the Python model class for accessing this type of content."
+        lastdot = self.model.rfind('.')
+        package = lastdot > 0 and self.model[:lastdot] or ''
+        module = __import__(package, '', '', [''])
+        return getattr(module, self.model[lastdot+1:])
 
     def get_object_for_this_type(self, **kwargs):
         """
@@ -38,4 +27,4 @@
         method. The ObjectNotExist exception, if thrown, will not be caught,
         so code that calls this method should catch it.
         """
-        return self.get_model_module().get_object(**kwargs)
+        return self.get_model_module().objects.get_object(**kwargs)
Index: django/parts/auth/formfields.py
===================================================================
--- django/parts/auth/formfields.py	(revision 2205)
+++ django/parts/auth/formfields.py	(working copy)
@@ -29,7 +29,7 @@
 
     def isValidUser(self, field_data, all_data):
         try:
-            self.user_cache = User.objects.get_object(username__exact=field_data)
+            self.user_cache = User.objects.get(username=field_data)
         except User.DoesNotExist:
             raise validators.ValidationError, _("Please enter a correct username and password. Note that both fields are case-sensitive.")
 
Index: django/contrib/redirects/middleware.py
===================================================================
--- django/contrib/redirects/middleware.py	(revision 2205)
+++ django/contrib/redirects/middleware.py	(working copy)
@@ -8,14 +8,14 @@
             return response # No need to check for a redirect for non-404 responses.
         path = request.get_full_path()
         try:
-            r = Redirect.objects.get_object(site__id__exact=settings.SITE_ID, old_path__exact=path)
+            r = Redirect.objects.get(site__id__exact=settings.SITE_ID, old_path__exact=path)
         except Redirect.DoesNotExist:
             r = None
         if r is None and settings.APPEND_SLASH:
             # Try removing the trailing slash.
             try:
-                r = Redirect.objects.get_object(site__id__exact=settings.SITE_ID,
-                    old_path__exact=path[:path.rfind('/')]+path[path.rfind('/')+1:])
+                r = Redirect.objects.get(site__id__exact=settings.SITE_ID,
+                    old_path=path[:path.rfind('/')]+path[path.rfind('/')+1:])
             except Redirect.DoesNotExist:
                 pass
         if r is not None:
Index: django/contrib/sessions/middleware.py
===================================================================
--- django/contrib/sessions/middleware.py	(revision 2205)
+++ django/contrib/sessions/middleware.py	(working copy)
@@ -46,7 +46,7 @@
                 self._session_cache = {}
             else:
                 try:
-                    s = Session.objects.get_object(session_key__exact=self.session_key,
+                    s = Session.objects.get(session_key=self.session_key,
                         expire_date__gt=datetime.datetime.now())
                     self._session_cache = s.get_decoded()
                 except Session.DoesNotExist:
Index: django/contrib/sessions/models.py
===================================================================
--- django/contrib/sessions/models.py	(revision 2205)
+++ django/contrib/sessions/models.py	(working copy)
@@ -18,13 +18,13 @@
         while 1:
             session_key = md5.new(str(random.randint(0, sys.maxint - 1)) + str(random.randint(0, sys.maxint - 1)) + settings.SECRET_KEY).hexdigest()
             try:
-                self.get_object(session_key__exact=session_key)
-            except self.klass.DoesNotExist:
+                self.get(session_key=session_key)
+            except self.model.DoesNotExist:
                 break
         return session_key
 
     def save(self, session_key, session_dict, expire_date):
-        s = self.klass(session_key, self.encode(session_dict), expire_date)
+        s = self.model(session_key, self.encode(session_dict), expire_date)
         if session_dict:
             s.save()
         else:
Index: django/shortcuts/__init__.py
===================================================================
--- django/shortcuts/__init__.py	(revision 2205)
+++ django/shortcuts/__init__.py	(working copy)
@@ -12,7 +12,7 @@
 
 def get_object_or_404(klass, **kwargs):
     try:
-        return klass._default_manager.get_object(**kwargs)
+        return klass._default_manager.get(**kwargs)
     except klass.DoesNotExist:
         raise Http404
 
Index: django/contrib/sites/models.py
===================================================================
--- django/contrib/sites/models.py	(revision 2205)
+++ django/contrib/sites/models.py	(working copy)
@@ -4,7 +4,7 @@
 class SiteManager(models.Manager):
     def get_current(self):
         from django.conf import settings
-        return self.get_object(pk=settings.SITE_ID)
+        return self.get(pk=settings.SITE_ID)
 
 class Site(models.Model):
     domain = models.CharField(_('domain name'), maxlength=100)
Index: django/contrib/syndication/feeds.py
===================================================================
--- django/contrib/syndication/feeds.py	(revision 2205)
+++ django/contrib/syndication/feeds.py	(working copy)
@@ -46,7 +46,7 @@
         """
         if url:
             try:
-                obj = self.get_object(url.split('/'))
+                obj = self.get(url.split('/'))
             except (AttributeError, ObjectDoesNotExist):
                 raise FeedDoesNotExist
         else: